﻿@{
    ViewBag.Title = "Home Page";
}

<div class="jumbotron">
    <h1>jsChart demo is @Html.ActionLink("over here", "index", "charts", null, null).</h1>
    <p>
        Everything else that you see here is simply stock standard ASP.NET MVC template junk that I just didn't remove.
        Start with the @Html.ActionLink("charts landing page", "index", "charts", null, null) to review.
    </p>
    <p>
        <small>Also, please scroll down to check out the notes provided here and on the charts landing page.</small>
    </p>
</div>

<div class="row">
    <div class="col-md-4">
        <h2>Why ASP.NET MVC?</h2>
        <p>
            The only reason I needed a server-side web appliation to exist at all for this demo was so that I could
            proxy the requests to third party domains for service calls in order to get around the cross-origin limiations
            of client script.
        </p>
        <p>
            I chose ASP.NET MVC because its quick for me, though I'm not sure if you'll have the tools needed to run
            the application and I don't have hosting for it anywhere.
        </p>
    </div>
    <div class="col-md-4">
        <h2>Grain of Salt</h2>
        <p>
            Normally a person would probably try to provide an example of their best work for a response to an interview.
            However, my goal here is to simply create something that works, and to create it quickly.
        </p>
        <p>
            There is a lot of stuff built into the stock MVC project template that isn't needed for this demo, but I chose
            to leave it all there instead of spending time removing things and cleaning up. The specialized code in this project
            all exists under the ChartsController controller class and its associated views.
        </p>
    </div>
    <div class="col-md-4">
        <h2>Script-Only Version</h2>
        <p>
            There is a client-side script-only version that demonstrates all of the same stuff in finer granularity without
            needing to make service requests to third party sources for data. I personally think that one is more interesting
            as it suggests a more specialized application that can provide finer controls over historical performance data,
            even though it doesn't demonstrate making AJAX calls or addressing your spefific requirements for stocks.
        </p>
        <p>
            <strong>Look for jsChartSimple directory</strong> next to this project on disk. You should be able to run jsChart.html in
            isolation directly from there. That is where I started before deciding I needed to proxy service calls for stocks.
        </p>
    </div>
</div>
<div class="row">
    <div class="col-md-4">
        <h2>Libraries Adopted</h2>
        <p>
            <a href="http://canvasjs.com" target="_blank"><strong>CanvasJS</strong></a> charting seemed like the most straight forward free charting
            library around. It does everything that I need it to do visually, offers event hookups for mouse interactions, and can accept
            new data over time without having to be completely re-initialized. Plus, the data format makes sense and it's generally more
            consistent with itself than something like Fusion Charts. I didn't feel that I could do any better by trying to create my
            own charting solution, and I just plain didn't have the time to try.
        </p>
        <p>
            <a href="http://knockoutjs.com" target="_blank"><strong>Knockout.js</strong></a> is good for simplifying UI development by encouarging
            more declarative langauge, and less script, in view markup. This is done by shifting the focus away from directly scripting
            against UI elements and more towards thinking about the actual model values and behaviors involved. The concept of an observable
            property enables change subscriptions and makes for a much more componentized and event-driven approach, which works
            well for single page applications as well as rapid prototyping.
        </p>
        <p>
            <a href="http://underscorejs.org" target="_blank"><strong>Underscore.js</strong></a> is a very handy library for working with script collections
            and arrays. I could do everything that underscore does without using underscore (and I've written my own versions of things
            like this more than a few times in the past), but why?
        </p>
        <p>
            <a href="http://momentjs.com" target="_blank"><strong>Moment.js</strong></a> does a very good job of simplifying and improving control
            and support for date values in Javascript. This is the most questionable library decision for this demo since I could pretty
            easilly strip it from the code that's here and do without, but I didn't.
        </p>
        <p>
            <a href="http://jquery.com" target="_blank"><strong>jQuery</strong></a> is only being used for its AJAX features. There is no need for
            any of its other features in this demo. Knockout handles a lot of the things that might look like jQuery in the UI without
            incurring any tight-coupling between the scripts and the markup elements.
        </p>
    </div>
    <div class="col-md-4">
        <h2>Services Adopted</h2>
        <p>
            I'm using the <strong>Yahoo Finance CSV and YQL APIs</strong> for these demos. The CSV API requires a service proxy passthrough
            in order to get around same origin policy limitations in client script, but the YQL APIs are a bit more open
            and are able to return JSON to any origin host. (However, this still means that the web application is needed
            because just running a static HTML file from the file system doesn't offer an actual origin host name, so script
            calls to the third party domains are rejected in that context.)
        </p>
        <p>
            I originally tried to use the Google Finance CSV API because it seemed to give me a larger data set and
            was more easilly accessed without having to include the service proxy. It is no longer supported, however, and
            the responses from the service seemed to ignore whatever dates I tried to pass into it.
        </p>
    </div>
    <div class="col-md-4">
        <h2>Service Problems</h2>
        <p>
            The free stock services are convenient but limited. Even though the application works as intended (and you can
            verify the requests that are being made by watching the script console or by using something like Fidler), the services
            don't offer either long term historical data or live intra-day information. I can get end of day quotes over time up
            to a few months at a time, or I can get single current value quotes, one at a time. The free services don't provide
            the granularity of data that your excercise requirements are asking for, so you may decide to see this as a failure.
        </p>
        <p>
            You might want to look at the stand-alone script-only performance chart demo located in the file system next to this project
            in a directory called jsChartSimple to see an example with more live, though simulated, information getting rendered.
        </p>
        <p>
            Also, in general, a more fully developed application would be better hardened against exceptions and the code could
            be streamlined quite a lot, I think.
        </p>
    </div>
</div>
